#include <bits/stdc++.h>
using namespace std;
int n,a[100005],q,t,k,x,bitovi[35],stepeniDvojke[35];
void uBinarno(int x){
    int counter=1;
    while(x>0){
        if(x%2==1)
            bitovi[counter]++;
        x/=2;
        counter++;
    }
}
void obrisiBinarno(int x){
    int counter=1;
    while(a[x]>0){
        if(a[x]%2==1)
            bitovi[counter]--;
        a[x]/=2;
        counter++;
    }
    return;
}
void stepenDvojke(){
    stepeniDvojke[1]=1;
    for(int i=2; i<=31; i++){
        stepeniDvojke[i]=stepeniDvojke[i-1]*2;
        //cout << stepeniDvojke[i] << endl;
    }
}
int ispisiVrednost(int x){
    int sol=0;
    for(int i=1; i<=32; i++){
        if(bitovi[i]>=x)
            sol+=stepeniDvojke[i];
    }
    return sol;
}
void ispisiBitove(){
    for(int i=1; i<=32; i++)
        cout << bitovi[i] << " ";
    cout << "\n";
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    stepenDvojke();
    cin >> n;
    for(int i=1; i<=n; i++){
        cin >> a[i];
        uBinarno(a[i]);
    }
    //ispisiBitove();
    cin >> q;
    for(int i=1; i<=q; i++){
        cin >> t;
        if(t==0){
            cin >> k;
            cout << ispisiVrednost(k) << "\n";
        }
        else{
            cin >> k >> x;
            obrisiBinarno(k);
            uBinarno(x);
            //ispisiBitove();
        }
    }
    return 0;
}
//ukupan broj bitova